%global gem_name concurrent-ruby
Name:                rubygem-%{gem_name}
Version:             1.0.5
Release:             1
Summary:             Modern concurrency tools for Ruby
License:             MIT
URL:                 http://www.concurrent-ruby.com
Source0:             https://rubygems.org/gems/%{gem_name}-%{version}.gem
Source1:             https://github.com/ruby-concurrency/concurrent-ruby/archive/v1.0.5.tar.gz
# Avoid sporadic test failures due to wrong object_id formatting.
# https://github.com/ruby-concurrency/concurrent-ruby/pull/651
Patch1:              concurrent-ruby-1.0.5-fix-inspect-output.patch
BuildRequires:       ruby(release) rubygems-devel ruby >= 1.9.3 rubygem(rspec) rubygem(timecop)
BuildArch:           noarch
%description
Modern concurrency tools including agents, futures, promises, thread pools,
actors, supervisors, and more.
Inspired by Erlang, Clojure, Go, JavaScript, actors, and classic concurrency
patterns.

%package doc
Summary:             Documentation for %{name}
Requires:            %{name} = %{version}-%{release}
BuildArch:           noarch
%description doc
Documentation for %{name}.

%prep
gem unpack %{SOURCE0}
%setup -q -D -T -n  %{gem_name}-%{version}
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
%patch1 -p1

%build
gem build %{gem_name}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

%check
pushd .%{gem_instdir}
tar xzf %{SOURCE1}
ln -s v1.0.5/spec spec
sed -i '/require.*concurrent-edge/ s/^/#/' spec/spec_helper.rb
sed -i '/allow_c_extensions?/,/^      end/ s/^/#/' spec/concurrent/atomic/atomic_reference_spec.rb
rspec -rspec_helper \
  --exclude-pattern 'spec/concurrent/{actor_spec.rb,channel_spec.rb,lazy_register_spec.rb,channel/**/*,atomic/atomic_markable_reference_spec.rb,edge/**/*}' \
  spec
popd

%files
%dir %{gem_instdir}
%license %{gem_instdir}/LICENSE.txt
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.md
%doc %{gem_instdir}/README.md

%changelog
* Tue Aug 18 2020 wanglin <wanglin175@huawei.com> - 1.0.5-1
- package init
